# std::unordered_set<Key,Hash,KeyEqual,Allocator>::extract

From cppreference.com
< cpp‎ | container‎ | unordered set

node_type extract( const_iterator position ); | (1) | (since C++17)
node_type extract( const key_type& x ); | (2) | (since C++17)

1) Unlinks the node that contains the element pointed to by `position` and returns a node handle that owns it
2) If the container has an element with key equivalent to `x`, unlinks the node that contains that element from the container and returns a node handle that owns it. Otherwise, returns an empty node handle.

In either case, no elements are copied or moved, only the internal pointers of the container nodes are repointed

Extracting a node invalidates only the iterators to the extracted element, and preserves the relative order of the elements that are not erased. Pointers and references to the extracted element remain valid, but cannot be used while element is owned by a node handle: they become usable if the element is inserted into a container.

### Parameters

position | - | a valid iterator into this container
x | - | a key to identify the node to be extracted

### Return value

A node handle that owns the extracted element, or empty node handle in case the element is not found in overload (2)

### Complexity

1,2) Average case O(1), worst case O(a.size()).

### Notes

extract is the only way to take a move-only object out of a set

    set<move_only_type> s;
    s.emplace(...);
    move_only_type mot = move(s.extract(s.begin()).value());

### Example

| This section is incomplete Reason: no example

### See also

merge (C++17) | splices nodes from another container (public member function)
insert | inserts elements or nodes (since C++17) (public member function)
erase | erases elements (public member function)

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/container/unordered_set/extract&oldid=104960"